"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from documenso_sdk import utils
from documenso_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from enum import Enum
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class RecipientCreateDocumentRecipientRoleRequestBody(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientCreateDocumentRecipientAccessAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientCreateDocumentRecipientActionAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientCreateDocumentRecipientRecipientTypedDict(TypedDict):
    email: str
    name: str
    role: RecipientCreateDocumentRecipientRoleRequestBody
    signing_order: NotRequired[float]
    access_auth: NotRequired[
        Nullable[RecipientCreateDocumentRecipientAccessAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: NotRequired[
        Nullable[RecipientCreateDocumentRecipientActionAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientCreateDocumentRecipientRecipient(BaseModel):
    email: str

    name: str

    role: RecipientCreateDocumentRecipientRoleRequestBody

    signing_order: Annotated[Optional[float], pydantic.Field(alias="signingOrder")] = (
        None
    )

    access_auth: Annotated[
        OptionalNullable[RecipientCreateDocumentRecipientAccessAuthRequestBody],
        pydantic.Field(alias="accessAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        OptionalNullable[RecipientCreateDocumentRecipientActionAuthRequestBody],
        pydantic.Field(alias="actionAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["signingOrder", "accessAuth", "actionAuth"]
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientCreateDocumentRecipientRequestTypedDict(TypedDict):
    document_id: float
    recipient: RecipientCreateDocumentRecipientRecipientTypedDict


class RecipientCreateDocumentRecipientRequest(BaseModel):
    document_id: Annotated[float, pydantic.Field(alias="documentId")]

    recipient: RecipientCreateDocumentRecipientRecipient


class RecipientCreateDocumentRecipientInternalServerErrorIssueTypedDict(TypedDict):
    message: str


class RecipientCreateDocumentRecipientInternalServerErrorIssue(BaseModel):
    message: str


class RecipientCreateDocumentRecipientInternalServerErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[RecipientCreateDocumentRecipientInternalServerErrorIssue]] = (
        None
    )


class RecipientCreateDocumentRecipientInternalServerError(Exception):
    r"""Internal server error"""

    data: RecipientCreateDocumentRecipientInternalServerErrorData

    def __init__(self, data: RecipientCreateDocumentRecipientInternalServerErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientCreateDocumentRecipientInternalServerErrorData
        )


class RecipientCreateDocumentRecipientBadRequestIssueTypedDict(TypedDict):
    message: str


class RecipientCreateDocumentRecipientBadRequestIssue(BaseModel):
    message: str


class RecipientCreateDocumentRecipientBadRequestErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[RecipientCreateDocumentRecipientBadRequestIssue]] = None


class RecipientCreateDocumentRecipientBadRequestError(Exception):
    r"""Invalid input data"""

    data: RecipientCreateDocumentRecipientBadRequestErrorData

    def __init__(self, data: RecipientCreateDocumentRecipientBadRequestErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientCreateDocumentRecipientBadRequestErrorData
        )


class RecipientCreateDocumentRecipientRoleResponse(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientCreateDocumentRecipientReadStatus(str, Enum):
    NOT_OPENED = "NOT_OPENED"
    OPENED = "OPENED"


class RecipientCreateDocumentRecipientSigningStatus(str, Enum):
    NOT_SIGNED = "NOT_SIGNED"
    SIGNED = "SIGNED"
    REJECTED = "REJECTED"


class RecipientCreateDocumentRecipientSendStatus(str, Enum):
    NOT_SENT = "NOT_SENT"
    SENT = "SENT"


class RecipientCreateDocumentRecipientAccessAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientCreateDocumentRecipientActionAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientCreateDocumentRecipientAuthOptionsTypedDict(TypedDict):
    access_auth: Nullable[RecipientCreateDocumentRecipientAccessAuthResponse]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: Nullable[RecipientCreateDocumentRecipientActionAuthResponse]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientCreateDocumentRecipientAuthOptions(BaseModel):
    access_auth: Annotated[
        Nullable[RecipientCreateDocumentRecipientAccessAuthResponse],
        pydantic.Field(alias="accessAuth"),
    ]
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        Nullable[RecipientCreateDocumentRecipientActionAuthResponse],
        pydantic.Field(alias="actionAuth"),
    ]
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientCreateDocumentRecipientResponseTypedDict(TypedDict):
    r"""Successful response"""

    role: RecipientCreateDocumentRecipientRoleResponse
    read_status: RecipientCreateDocumentRecipientReadStatus
    signing_status: RecipientCreateDocumentRecipientSigningStatus
    send_status: RecipientCreateDocumentRecipientSendStatus
    id: float
    document_id: Nullable[float]
    template_id: Nullable[float]
    email: str
    name: str
    token: str
    document_deleted_at: Nullable[str]
    expired: Nullable[str]
    signed_at: Nullable[str]
    auth_options: Nullable[RecipientCreateDocumentRecipientAuthOptionsTypedDict]
    signing_order: Nullable[float]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""
    rejection_reason: Nullable[str]


class RecipientCreateDocumentRecipientResponse(BaseModel):
    r"""Successful response"""

    role: RecipientCreateDocumentRecipientRoleResponse

    read_status: Annotated[
        RecipientCreateDocumentRecipientReadStatus, pydantic.Field(alias="readStatus")
    ]

    signing_status: Annotated[
        RecipientCreateDocumentRecipientSigningStatus,
        pydantic.Field(alias="signingStatus"),
    ]

    send_status: Annotated[
        RecipientCreateDocumentRecipientSendStatus, pydantic.Field(alias="sendStatus")
    ]

    id: float

    document_id: Annotated[Nullable[float], pydantic.Field(alias="documentId")]

    template_id: Annotated[Nullable[float], pydantic.Field(alias="templateId")]

    email: str

    name: str

    token: str

    document_deleted_at: Annotated[
        Nullable[str], pydantic.Field(alias="documentDeletedAt")
    ]

    expired: Nullable[str]

    signed_at: Annotated[Nullable[str], pydantic.Field(alias="signedAt")]

    auth_options: Annotated[
        Nullable[RecipientCreateDocumentRecipientAuthOptions],
        pydantic.Field(alias="authOptions"),
    ]

    signing_order: Annotated[Nullable[float], pydantic.Field(alias="signingOrder")]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""

    rejection_reason: Annotated[Nullable[str], pydantic.Field(alias="rejectionReason")]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = [
            "documentId",
            "templateId",
            "documentDeletedAt",
            "expired",
            "signedAt",
            "authOptions",
            "signingOrder",
            "rejectionReason",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
