"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from documenso_sdk import utils
from documenso_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from enum import Enum
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class RecipientCreateDocumentRecipientsRoleRequestBody(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientCreateDocumentRecipientsAccessAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientCreateDocumentRecipientsActionAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientCreateDocumentRecipientsRecipientRequestBodyTypedDict(TypedDict):
    email: str
    name: str
    role: RecipientCreateDocumentRecipientsRoleRequestBody
    signing_order: NotRequired[float]
    access_auth: NotRequired[
        Nullable[RecipientCreateDocumentRecipientsAccessAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: NotRequired[
        Nullable[RecipientCreateDocumentRecipientsActionAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientCreateDocumentRecipientsRecipientRequestBody(BaseModel):
    email: str

    name: str

    role: RecipientCreateDocumentRecipientsRoleRequestBody

    signing_order: Annotated[Optional[float], pydantic.Field(alias="signingOrder")] = (
        None
    )

    access_auth: Annotated[
        OptionalNullable[RecipientCreateDocumentRecipientsAccessAuthRequestBody],
        pydantic.Field(alias="accessAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        OptionalNullable[RecipientCreateDocumentRecipientsActionAuthRequestBody],
        pydantic.Field(alias="actionAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["signingOrder", "accessAuth", "actionAuth"]
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientCreateDocumentRecipientsRequestTypedDict(TypedDict):
    document_id: float
    recipients: List[RecipientCreateDocumentRecipientsRecipientRequestBodyTypedDict]


class RecipientCreateDocumentRecipientsRequest(BaseModel):
    document_id: Annotated[float, pydantic.Field(alias="documentId")]

    recipients: List[RecipientCreateDocumentRecipientsRecipientRequestBody]


class RecipientCreateDocumentRecipientsInternalServerErrorIssueTypedDict(TypedDict):
    message: str


class RecipientCreateDocumentRecipientsInternalServerErrorIssue(BaseModel):
    message: str


class RecipientCreateDocumentRecipientsInternalServerErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[
        List[RecipientCreateDocumentRecipientsInternalServerErrorIssue]
    ] = None


class RecipientCreateDocumentRecipientsInternalServerError(Exception):
    r"""Internal server error"""

    data: RecipientCreateDocumentRecipientsInternalServerErrorData

    def __init__(self, data: RecipientCreateDocumentRecipientsInternalServerErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientCreateDocumentRecipientsInternalServerErrorData
        )


class RecipientCreateDocumentRecipientsBadRequestIssueTypedDict(TypedDict):
    message: str


class RecipientCreateDocumentRecipientsBadRequestIssue(BaseModel):
    message: str


class RecipientCreateDocumentRecipientsBadRequestErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[RecipientCreateDocumentRecipientsBadRequestIssue]] = None


class RecipientCreateDocumentRecipientsBadRequestError(Exception):
    r"""Invalid input data"""

    data: RecipientCreateDocumentRecipientsBadRequestErrorData

    def __init__(self, data: RecipientCreateDocumentRecipientsBadRequestErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientCreateDocumentRecipientsBadRequestErrorData
        )


class RecipientCreateDocumentRecipientsRoleResponse(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientCreateDocumentRecipientsReadStatus(str, Enum):
    NOT_OPENED = "NOT_OPENED"
    OPENED = "OPENED"


class RecipientCreateDocumentRecipientsSigningStatus(str, Enum):
    NOT_SIGNED = "NOT_SIGNED"
    SIGNED = "SIGNED"
    REJECTED = "REJECTED"


class RecipientCreateDocumentRecipientsSendStatus(str, Enum):
    NOT_SENT = "NOT_SENT"
    SENT = "SENT"


class RecipientCreateDocumentRecipientsAccessAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientCreateDocumentRecipientsActionAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientCreateDocumentRecipientsAuthOptionsTypedDict(TypedDict):
    access_auth: Nullable[RecipientCreateDocumentRecipientsAccessAuthResponse]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: Nullable[RecipientCreateDocumentRecipientsActionAuthResponse]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientCreateDocumentRecipientsAuthOptions(BaseModel):
    access_auth: Annotated[
        Nullable[RecipientCreateDocumentRecipientsAccessAuthResponse],
        pydantic.Field(alias="accessAuth"),
    ]
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        Nullable[RecipientCreateDocumentRecipientsActionAuthResponse],
        pydantic.Field(alias="actionAuth"),
    ]
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientCreateDocumentRecipientsRecipientResponseTypedDict(TypedDict):
    role: RecipientCreateDocumentRecipientsRoleResponse
    read_status: RecipientCreateDocumentRecipientsReadStatus
    signing_status: RecipientCreateDocumentRecipientsSigningStatus
    send_status: RecipientCreateDocumentRecipientsSendStatus
    id: float
    document_id: Nullable[float]
    template_id: Nullable[float]
    email: str
    name: str
    token: str
    document_deleted_at: Nullable[str]
    expired: Nullable[str]
    signed_at: Nullable[str]
    auth_options: Nullable[RecipientCreateDocumentRecipientsAuthOptionsTypedDict]
    signing_order: Nullable[float]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""
    rejection_reason: Nullable[str]


class RecipientCreateDocumentRecipientsRecipientResponse(BaseModel):
    role: RecipientCreateDocumentRecipientsRoleResponse

    read_status: Annotated[
        RecipientCreateDocumentRecipientsReadStatus, pydantic.Field(alias="readStatus")
    ]

    signing_status: Annotated[
        RecipientCreateDocumentRecipientsSigningStatus,
        pydantic.Field(alias="signingStatus"),
    ]

    send_status: Annotated[
        RecipientCreateDocumentRecipientsSendStatus, pydantic.Field(alias="sendStatus")
    ]

    id: float

    document_id: Annotated[Nullable[float], pydantic.Field(alias="documentId")]

    template_id: Annotated[Nullable[float], pydantic.Field(alias="templateId")]

    email: str

    name: str

    token: str

    document_deleted_at: Annotated[
        Nullable[str], pydantic.Field(alias="documentDeletedAt")
    ]

    expired: Nullable[str]

    signed_at: Annotated[Nullable[str], pydantic.Field(alias="signedAt")]

    auth_options: Annotated[
        Nullable[RecipientCreateDocumentRecipientsAuthOptions],
        pydantic.Field(alias="authOptions"),
    ]

    signing_order: Annotated[Nullable[float], pydantic.Field(alias="signingOrder")]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""

    rejection_reason: Annotated[Nullable[str], pydantic.Field(alias="rejectionReason")]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = [
            "documentId",
            "templateId",
            "documentDeletedAt",
            "expired",
            "signedAt",
            "authOptions",
            "signingOrder",
            "rejectionReason",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientCreateDocumentRecipientsResponseTypedDict(TypedDict):
    r"""Successful response"""

    recipients: List[RecipientCreateDocumentRecipientsRecipientResponseTypedDict]


class RecipientCreateDocumentRecipientsResponse(BaseModel):
    r"""Successful response"""

    recipients: List[RecipientCreateDocumentRecipientsRecipientResponse]
