"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from documenso_sdk import utils
from documenso_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from enum import Enum
import pydantic
from pydantic import model_serializer
from typing import Any, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class RecipientUpdateTemplateRecipientRoleRequestBody(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientUpdateTemplateRecipientAccessAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientUpdateTemplateRecipientActionAuthRequestBody(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientUpdateTemplateRecipientRecipientTypedDict(TypedDict):
    id: float
    r"""The ID of the recipient to update."""
    email: NotRequired[str]
    name: NotRequired[str]
    role: NotRequired[RecipientUpdateTemplateRecipientRoleRequestBody]
    signing_order: NotRequired[float]
    access_auth: NotRequired[
        Nullable[RecipientUpdateTemplateRecipientAccessAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: NotRequired[
        Nullable[RecipientUpdateTemplateRecipientActionAuthRequestBody]
    ]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientUpdateTemplateRecipientRecipient(BaseModel):
    id: float
    r"""The ID of the recipient to update."""

    email: Optional[str] = None

    name: Optional[str] = None

    role: Optional[RecipientUpdateTemplateRecipientRoleRequestBody] = None

    signing_order: Annotated[Optional[float], pydantic.Field(alias="signingOrder")] = (
        None
    )

    access_auth: Annotated[
        OptionalNullable[RecipientUpdateTemplateRecipientAccessAuthRequestBody],
        pydantic.Field(alias="accessAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        OptionalNullable[RecipientUpdateTemplateRecipientActionAuthRequestBody],
        pydantic.Field(alias="actionAuth"),
    ] = UNSET
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "email",
            "name",
            "role",
            "signingOrder",
            "accessAuth",
            "actionAuth",
        ]
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientUpdateTemplateRecipientRequestTypedDict(TypedDict):
    template_id: float
    recipient: RecipientUpdateTemplateRecipientRecipientTypedDict


class RecipientUpdateTemplateRecipientRequest(BaseModel):
    template_id: Annotated[float, pydantic.Field(alias="templateId")]

    recipient: RecipientUpdateTemplateRecipientRecipient


class RecipientUpdateTemplateRecipientInternalServerErrorIssueTypedDict(TypedDict):
    message: str


class RecipientUpdateTemplateRecipientInternalServerErrorIssue(BaseModel):
    message: str


class RecipientUpdateTemplateRecipientInternalServerErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[RecipientUpdateTemplateRecipientInternalServerErrorIssue]] = (
        None
    )


class RecipientUpdateTemplateRecipientInternalServerError(Exception):
    r"""Internal server error"""

    data: RecipientUpdateTemplateRecipientInternalServerErrorData

    def __init__(self, data: RecipientUpdateTemplateRecipientInternalServerErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientUpdateTemplateRecipientInternalServerErrorData
        )


class RecipientUpdateTemplateRecipientBadRequestIssueTypedDict(TypedDict):
    message: str


class RecipientUpdateTemplateRecipientBadRequestIssue(BaseModel):
    message: str


class RecipientUpdateTemplateRecipientBadRequestErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[RecipientUpdateTemplateRecipientBadRequestIssue]] = None


class RecipientUpdateTemplateRecipientBadRequestError(Exception):
    r"""Invalid input data"""

    data: RecipientUpdateTemplateRecipientBadRequestErrorData

    def __init__(self, data: RecipientUpdateTemplateRecipientBadRequestErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, RecipientUpdateTemplateRecipientBadRequestErrorData
        )


class RecipientUpdateTemplateRecipientRoleResponse(str, Enum):
    CC = "CC"
    SIGNER = "SIGNER"
    VIEWER = "VIEWER"
    APPROVER = "APPROVER"
    ASSISTANT = "ASSISTANT"


class RecipientUpdateTemplateRecipientReadStatus(str, Enum):
    NOT_OPENED = "NOT_OPENED"
    OPENED = "OPENED"


class RecipientUpdateTemplateRecipientSigningStatus(str, Enum):
    NOT_SIGNED = "NOT_SIGNED"
    SIGNED = "SIGNED"
    REJECTED = "REJECTED"


class RecipientUpdateTemplateRecipientSendStatus(str, Enum):
    NOT_SENT = "NOT_SENT"
    SENT = "SENT"


class RecipientUpdateTemplateRecipientAccessAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class RecipientUpdateTemplateRecipientActionAuthResponse(str, Enum):
    r"""The type of authentication required for the recipient to sign the document."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"
    EXPLICIT_NONE = "EXPLICIT_NONE"


class RecipientUpdateTemplateRecipientAuthOptionsTypedDict(TypedDict):
    access_auth: Nullable[RecipientUpdateTemplateRecipientAccessAuthResponse]
    r"""The type of authentication required for the recipient to access the document."""
    action_auth: Nullable[RecipientUpdateTemplateRecipientActionAuthResponse]
    r"""The type of authentication required for the recipient to sign the document."""


class RecipientUpdateTemplateRecipientAuthOptions(BaseModel):
    access_auth: Annotated[
        Nullable[RecipientUpdateTemplateRecipientAccessAuthResponse],
        pydantic.Field(alias="accessAuth"),
    ]
    r"""The type of authentication required for the recipient to access the document."""

    action_auth: Annotated[
        Nullable[RecipientUpdateTemplateRecipientActionAuthResponse],
        pydantic.Field(alias="actionAuth"),
    ]
    r"""The type of authentication required for the recipient to sign the document."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["accessAuth", "actionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientUpdateTemplateRecipientType(str, Enum):
    SIGNATURE = "SIGNATURE"
    FREE_SIGNATURE = "FREE_SIGNATURE"
    INITIALS = "INITIALS"
    NAME = "NAME"
    EMAIL = "EMAIL"
    DATE = "DATE"
    TEXT = "TEXT"
    NUMBER = "NUMBER"
    RADIO = "RADIO"
    CHECKBOX = "CHECKBOX"
    DROPDOWN = "DROPDOWN"


class RecipientUpdateTemplateRecipientTypeDropdown(str, Enum):
    DROPDOWN = "dropdown"


class RecipientUpdateTemplateRecipientValue3TypedDict(TypedDict):
    value: str


class RecipientUpdateTemplateRecipientValue3(BaseModel):
    value: str


class RecipientUpdateTemplateRecipientFieldMetaDropdownTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeDropdown
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    values: NotRequired[List[RecipientUpdateTemplateRecipientValue3TypedDict]]
    default_value: NotRequired[str]


class RecipientUpdateTemplateRecipientFieldMetaDropdown(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeDropdown

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    values: Optional[List[RecipientUpdateTemplateRecipientValue3]] = None

    default_value: Annotated[Optional[str], pydantic.Field(alias="defaultValue")] = None


class RecipientUpdateTemplateRecipientTypeCheckbox(str, Enum):
    CHECKBOX = "checkbox"


class RecipientUpdateTemplateRecipientValue2TypedDict(TypedDict):
    id: float
    checked: bool
    value: str


class RecipientUpdateTemplateRecipientValue2(BaseModel):
    id: float

    checked: bool

    value: str


class RecipientUpdateTemplateRecipientFieldMetaCheckboxTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeCheckbox
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    values: NotRequired[List[RecipientUpdateTemplateRecipientValue2TypedDict]]
    validation_rule: NotRequired[str]
    validation_length: NotRequired[float]


class RecipientUpdateTemplateRecipientFieldMetaCheckbox(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeCheckbox

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    values: Optional[List[RecipientUpdateTemplateRecipientValue2]] = None

    validation_rule: Annotated[
        Optional[str], pydantic.Field(alias="validationRule")
    ] = None

    validation_length: Annotated[
        Optional[float], pydantic.Field(alias="validationLength")
    ] = None


class RecipientUpdateTemplateRecipientTypeRadio(str, Enum):
    RADIO = "radio"


class RecipientUpdateTemplateRecipientValue1TypedDict(TypedDict):
    id: float
    checked: bool
    value: str


class RecipientUpdateTemplateRecipientValue1(BaseModel):
    id: float

    checked: bool

    value: str


class RecipientUpdateTemplateRecipientFieldMetaRadioTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeRadio
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    values: NotRequired[List[RecipientUpdateTemplateRecipientValue1TypedDict]]


class RecipientUpdateTemplateRecipientFieldMetaRadio(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeRadio

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    values: Optional[List[RecipientUpdateTemplateRecipientValue1]] = None


class RecipientUpdateTemplateRecipientTypeNumber(str, Enum):
    NUMBER = "number"


class RecipientUpdateTemplateRecipientTextAlign6(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaNumberTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeNumber
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    number_format: NotRequired[str]
    value: NotRequired[str]
    min_value: NotRequired[float]
    max_value: NotRequired[float]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign6]


class RecipientUpdateTemplateRecipientFieldMetaNumber(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeNumber

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    number_format: Annotated[Optional[str], pydantic.Field(alias="numberFormat")] = None

    value: Optional[str] = None

    min_value: Annotated[Optional[float], pydantic.Field(alias="minValue")] = None

    max_value: Annotated[Optional[float], pydantic.Field(alias="maxValue")] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign6],
        pydantic.Field(alias="textAlign"),
    ] = None


class RecipientUpdateTemplateRecipientTypeText(str, Enum):
    TEXT = "text"


class RecipientUpdateTemplateRecipientTextAlign5(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaTextTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeText
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    text: NotRequired[str]
    character_limit: NotRequired[float]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign5]


class RecipientUpdateTemplateRecipientFieldMetaText(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeText

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    text: Optional[str] = None

    character_limit: Annotated[
        Optional[float], pydantic.Field(alias="characterLimit")
    ] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign5],
        pydantic.Field(alias="textAlign"),
    ] = None


class RecipientUpdateTemplateRecipientTypeDate(str, Enum):
    DATE = "date"


class RecipientUpdateTemplateRecipientTextAlign4(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaDateTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeDate
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign4]


class RecipientUpdateTemplateRecipientFieldMetaDate(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeDate

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign4],
        pydantic.Field(alias="textAlign"),
    ] = None


class RecipientUpdateTemplateRecipientTypeEmail(str, Enum):
    EMAIL = "email"


class RecipientUpdateTemplateRecipientTextAlign3(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaEmailTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeEmail
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign3]


class RecipientUpdateTemplateRecipientFieldMetaEmail(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeEmail

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign3],
        pydantic.Field(alias="textAlign"),
    ] = None


class RecipientUpdateTemplateRecipientTypeName(str, Enum):
    NAME = "name"


class RecipientUpdateTemplateRecipientTextAlign2(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaNameTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeName
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign2]


class RecipientUpdateTemplateRecipientFieldMetaName(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeName

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign2],
        pydantic.Field(alias="textAlign"),
    ] = None


class RecipientUpdateTemplateRecipientTypeInitials(str, Enum):
    INITIALS = "initials"


class RecipientUpdateTemplateRecipientTextAlign1(str, Enum):
    LEFT = "left"
    CENTER = "center"
    RIGHT = "right"


class RecipientUpdateTemplateRecipientFieldMetaInitialsTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientTypeInitials
    label: NotRequired[str]
    placeholder: NotRequired[str]
    required: NotRequired[bool]
    read_only: NotRequired[bool]
    font_size: NotRequired[float]
    text_align: NotRequired[RecipientUpdateTemplateRecipientTextAlign1]


class RecipientUpdateTemplateRecipientFieldMetaInitials(BaseModel):
    type: RecipientUpdateTemplateRecipientTypeInitials

    label: Optional[str] = None

    placeholder: Optional[str] = None

    required: Optional[bool] = None

    read_only: Annotated[Optional[bool], pydantic.Field(alias="readOnly")] = None

    font_size: Annotated[Optional[float], pydantic.Field(alias="fontSize")] = None

    text_align: Annotated[
        Optional[RecipientUpdateTemplateRecipientTextAlign1],
        pydantic.Field(alias="textAlign"),
    ] = None


RecipientUpdateTemplateRecipientFieldMetaUnionTypedDict = TypeAliasType(
    "RecipientUpdateTemplateRecipientFieldMetaUnionTypedDict",
    Union[
        RecipientUpdateTemplateRecipientFieldMetaRadioTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaInitialsTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaNameTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaEmailTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaDateTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaDropdownTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaCheckboxTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaTextTypedDict,
        RecipientUpdateTemplateRecipientFieldMetaNumberTypedDict,
    ],
)


RecipientUpdateTemplateRecipientFieldMetaUnion = TypeAliasType(
    "RecipientUpdateTemplateRecipientFieldMetaUnion",
    Union[
        RecipientUpdateTemplateRecipientFieldMetaRadio,
        RecipientUpdateTemplateRecipientFieldMetaInitials,
        RecipientUpdateTemplateRecipientFieldMetaName,
        RecipientUpdateTemplateRecipientFieldMetaEmail,
        RecipientUpdateTemplateRecipientFieldMetaDate,
        RecipientUpdateTemplateRecipientFieldMetaDropdown,
        RecipientUpdateTemplateRecipientFieldMetaCheckbox,
        RecipientUpdateTemplateRecipientFieldMetaText,
        RecipientUpdateTemplateRecipientFieldMetaNumber,
    ],
)


class RecipientUpdateTemplateRecipientFieldTypedDict(TypedDict):
    type: RecipientUpdateTemplateRecipientType
    id: float
    secondary_id: str
    document_id: Nullable[float]
    template_id: Nullable[float]
    recipient_id: float
    page: float
    r"""The page number of the field on the document. Starts from 1."""
    custom_text: str
    inserted: bool
    field_meta: Nullable[RecipientUpdateTemplateRecipientFieldMetaUnionTypedDict]
    position_x: NotRequired[Any]
    position_y: NotRequired[Any]
    width: NotRequired[Any]
    height: NotRequired[Any]


class RecipientUpdateTemplateRecipientField(BaseModel):
    type: RecipientUpdateTemplateRecipientType

    id: float

    secondary_id: Annotated[str, pydantic.Field(alias="secondaryId")]

    document_id: Annotated[Nullable[float], pydantic.Field(alias="documentId")]

    template_id: Annotated[Nullable[float], pydantic.Field(alias="templateId")]

    recipient_id: Annotated[float, pydantic.Field(alias="recipientId")]

    page: float
    r"""The page number of the field on the document. Starts from 1."""

    custom_text: Annotated[str, pydantic.Field(alias="customText")]

    inserted: bool

    field_meta: Annotated[
        Nullable[RecipientUpdateTemplateRecipientFieldMetaUnion],
        pydantic.Field(alias="fieldMeta"),
    ]

    position_x: Annotated[Optional[Any], pydantic.Field(alias="positionX")] = None

    position_y: Annotated[Optional[Any], pydantic.Field(alias="positionY")] = None

    width: Optional[Any] = None

    height: Optional[Any] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["positionX", "positionY", "width", "height"]
        nullable_fields = ["documentId", "templateId", "fieldMeta"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class RecipientUpdateTemplateRecipientResponseTypedDict(TypedDict):
    r"""Successful response"""

    role: RecipientUpdateTemplateRecipientRoleResponse
    read_status: RecipientUpdateTemplateRecipientReadStatus
    signing_status: RecipientUpdateTemplateRecipientSigningStatus
    send_status: RecipientUpdateTemplateRecipientSendStatus
    id: float
    document_id: Nullable[float]
    template_id: Nullable[float]
    email: str
    name: str
    token: str
    document_deleted_at: Nullable[str]
    expired: Nullable[str]
    signed_at: Nullable[str]
    auth_options: Nullable[RecipientUpdateTemplateRecipientAuthOptionsTypedDict]
    signing_order: Nullable[float]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""
    rejection_reason: Nullable[str]
    fields: List[RecipientUpdateTemplateRecipientFieldTypedDict]


class RecipientUpdateTemplateRecipientResponse(BaseModel):
    r"""Successful response"""

    role: RecipientUpdateTemplateRecipientRoleResponse

    read_status: Annotated[
        RecipientUpdateTemplateRecipientReadStatus, pydantic.Field(alias="readStatus")
    ]

    signing_status: Annotated[
        RecipientUpdateTemplateRecipientSigningStatus,
        pydantic.Field(alias="signingStatus"),
    ]

    send_status: Annotated[
        RecipientUpdateTemplateRecipientSendStatus, pydantic.Field(alias="sendStatus")
    ]

    id: float

    document_id: Annotated[Nullable[float], pydantic.Field(alias="documentId")]

    template_id: Annotated[Nullable[float], pydantic.Field(alias="templateId")]

    email: str

    name: str

    token: str

    document_deleted_at: Annotated[
        Nullable[str], pydantic.Field(alias="documentDeletedAt")
    ]

    expired: Nullable[str]

    signed_at: Annotated[Nullable[str], pydantic.Field(alias="signedAt")]

    auth_options: Annotated[
        Nullable[RecipientUpdateTemplateRecipientAuthOptions],
        pydantic.Field(alias="authOptions"),
    ]

    signing_order: Annotated[Nullable[float], pydantic.Field(alias="signingOrder")]
    r"""The order in which the recipient should sign the document. Only works if the document is set to sequential signing."""

    rejection_reason: Annotated[Nullable[str], pydantic.Field(alias="rejectionReason")]

    fields: List[RecipientUpdateTemplateRecipientField]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = [
            "documentId",
            "templateId",
            "documentDeletedAt",
            "expired",
            "signedAt",
            "authOptions",
            "signingOrder",
            "rejectionReason",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
