"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from documenso_sdk import utils
from documenso_sdk.types import BaseModel, Nullable, UNSET_SENTINEL
from enum import Enum
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, TypedDict


class TemplateDuplicateTemplateRequestTypedDict(TypedDict):
    template_id: float


class TemplateDuplicateTemplateRequest(BaseModel):
    template_id: Annotated[float, pydantic.Field(alias="templateId")]


class TemplateDuplicateTemplateInternalServerErrorIssueTypedDict(TypedDict):
    message: str


class TemplateDuplicateTemplateInternalServerErrorIssue(BaseModel):
    message: str


class TemplateDuplicateTemplateInternalServerErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[TemplateDuplicateTemplateInternalServerErrorIssue]] = None


class TemplateDuplicateTemplateInternalServerError(Exception):
    r"""Internal server error"""

    data: TemplateDuplicateTemplateInternalServerErrorData

    def __init__(self, data: TemplateDuplicateTemplateInternalServerErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, TemplateDuplicateTemplateInternalServerErrorData
        )


class TemplateDuplicateTemplateBadRequestIssueTypedDict(TypedDict):
    message: str


class TemplateDuplicateTemplateBadRequestIssue(BaseModel):
    message: str


class TemplateDuplicateTemplateBadRequestErrorData(BaseModel):
    message: str

    code: str

    issues: Optional[List[TemplateDuplicateTemplateBadRequestIssue]] = None


class TemplateDuplicateTemplateBadRequestError(Exception):
    r"""Invalid input data"""

    data: TemplateDuplicateTemplateBadRequestErrorData

    def __init__(self, data: TemplateDuplicateTemplateBadRequestErrorData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, TemplateDuplicateTemplateBadRequestErrorData
        )


class TemplateDuplicateTemplateType(str, Enum):
    PUBLIC = "PUBLIC"
    PRIVATE = "PRIVATE"


class TemplateDuplicateTemplateVisibility(str, Enum):
    EVERYONE = "EVERYONE"
    MANAGER_AND_ABOVE = "MANAGER_AND_ABOVE"
    ADMIN = "ADMIN"


class TemplateDuplicateTemplateGlobalAccessAuth(str, Enum):
    r"""The type of authentication required for the recipient to access the document."""

    ACCOUNT = "ACCOUNT"


class TemplateDuplicateTemplateGlobalActionAuth(str, Enum):
    r"""The type of authentication required for the recipient to sign the document. This field is restricted to Enterprise plan users only."""

    ACCOUNT = "ACCOUNT"
    PASSKEY = "PASSKEY"
    TWO_FACTOR_AUTH = "TWO_FACTOR_AUTH"


class TemplateDuplicateTemplateAuthOptionsTypedDict(TypedDict):
    global_access_auth: Nullable[TemplateDuplicateTemplateGlobalAccessAuth]
    r"""The type of authentication required for the recipient to access the document."""
    global_action_auth: Nullable[TemplateDuplicateTemplateGlobalActionAuth]
    r"""The type of authentication required for the recipient to sign the document. This field is restricted to Enterprise plan users only."""


class TemplateDuplicateTemplateAuthOptions(BaseModel):
    global_access_auth: Annotated[
        Nullable[TemplateDuplicateTemplateGlobalAccessAuth],
        pydantic.Field(alias="globalAccessAuth"),
    ]
    r"""The type of authentication required for the recipient to access the document."""

    global_action_auth: Annotated[
        Nullable[TemplateDuplicateTemplateGlobalActionAuth],
        pydantic.Field(alias="globalActionAuth"),
    ]
    r"""The type of authentication required for the recipient to sign the document. This field is restricted to Enterprise plan users only."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["globalAccessAuth", "globalActionAuth"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class TemplateDuplicateTemplateResponseTypedDict(TypedDict):
    r"""Successful response"""

    type: TemplateDuplicateTemplateType
    visibility: TemplateDuplicateTemplateVisibility
    id: float
    external_id: Nullable[str]
    title: str
    user_id: float
    team_id: Nullable[float]
    auth_options: Nullable[TemplateDuplicateTemplateAuthOptionsTypedDict]
    template_document_data_id: str
    created_at: str
    updated_at: str
    public_title: str
    public_description: str


class TemplateDuplicateTemplateResponse(BaseModel):
    r"""Successful response"""

    type: TemplateDuplicateTemplateType

    visibility: TemplateDuplicateTemplateVisibility

    id: float

    external_id: Annotated[Nullable[str], pydantic.Field(alias="externalId")]

    title: str

    user_id: Annotated[float, pydantic.Field(alias="userId")]

    team_id: Annotated[Nullable[float], pydantic.Field(alias="teamId")]

    auth_options: Annotated[
        Nullable[TemplateDuplicateTemplateAuthOptions],
        pydantic.Field(alias="authOptions"),
    ]

    template_document_data_id: Annotated[
        str, pydantic.Field(alias="templateDocumentDataId")
    ]

    created_at: Annotated[str, pydantic.Field(alias="createdAt")]

    updated_at: Annotated[str, pydantic.Field(alias="updatedAt")]

    public_title: Annotated[str, pydantic.Field(alias="publicTitle")]

    public_description: Annotated[str, pydantic.Field(alias="publicDescription")]

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = []
        nullable_fields = ["externalId", "teamId", "authOptions"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
